

package simpleJavaApp;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.lang.reflect.*;
import com.rational.java2rei.*;

public class TRoseReflection 
{
  
   JTextArea RoseItemReflection;

   IRoseItem theRoseItem;
   IRoseItemCollection theItemCollection;
   IRoseDiagram theDiagram;
   IRoseDiagramCollection theDiagramCollection;

  
   public TRoseReflection() 
	{


		RoseItemReflection = new JTextArea("");
		RoseItemReflection.setRows(20);
		RoseItemReflection.setColumns(40);
		RoseItemReflection.setEditable(false);

		}

   public void updateText(IRoseApplication theApplication) 
   {
	int total = 0;
	int idx = 0;

	theItemCollection = theApplication.getCurrentModel().getSelectedItems();
	theDiagramCollection = theApplication.getCurrentModel().getSelectedDiagrams();

	//clear the existing text
	RoseItemReflection.setText("");

	for (short j = 1 ; j<= theItemCollection.getCount();j++){
	  theRoseItem = theItemCollection.getAt(j);	
	  String thisName = theRoseItem.identifyClass();
 	  RoseItemReflection.append(theRoseItem.getQualifiedName()+ ": "+thisName+"\n");
	  try{
	  Class thisClass = Class.forName("com.rational.java2rei.IRose"+thisName);
	  //Interfaces
          Class[] theInterfaces = thisClass.getInterfaces();
	  
          for(short i =0; i<theInterfaces.length;i++)
	  RoseItemReflection.append(" Interface: "+theInterfaces[i].getName()+"\n");
	  //Methods	
	  Method[] theMethods = thisClass.getMethods();
          for(short i =0; i<theMethods.length;i++)
	  RoseItemReflection.append(" Method: "+theMethods[i].getName()+"\n");

	  //Fields
	  Field[] theFields = thisClass.getDeclaredFields();
          for(short i =0; i<theFields.length;i++)		  
	  RoseItemReflection.append(" Declared field: "+theFields[i].getName()+"\n");
	}
	 catch(java.lang.ClassNotFoundException ex){};
	}

	for (short j = 1 ; j<= theDiagramCollection.getCount();j++){
	  theDiagram = theDiagramCollection.getAt(j);	
	  String thisName = theDiagram.identifyClass();
 	  RoseItemReflection.append(theDiagram.getQualifiedName()+ ": "+thisName+"\n");
	  try{
	  Class thisClass = Class.forName("com.rational.java2rei.IRose"+thisName);
	  //Interfaces
          Class[] theInterfaces = thisClass.getInterfaces();
	  
          for(short i =0; i<theInterfaces.length;i++)
	  RoseItemReflection.append(" Interface: "+theInterfaces[i].getName()+"\n");
	  //Methods	
	  Method[] theMethods = thisClass.getMethods();
          for(short i =0; i<theMethods.length;i++)
	  RoseItemReflection.append(" Method: "+theMethods[i].getName()+"\n");

	  //Fields
	  Field[] theFields = thisClass.getDeclaredFields();
          for(short i =0; i<theFields.length;i++)		  
	  RoseItemReflection.append(" Declared field: "+theFields[i].getName()+"\n");
	}
	 catch(java.lang.ClassNotFoundException ex){};
	}
		 
      }
   

   JTextArea getRoseItemReflection(){
	return RoseItemReflection;
   } 

}
